<?php
namespace Ep\Gath\Moto;

use Interop\Container\ContainerInterface;
use Zend\ServiceManager\Factory\FactoryInterface;

/**
 * Class MotoMiddlewareFactory
 *
 * @package Ep\Gath\Moto
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/gath
 */
class MotoMiddlewareFactory implements FactoryInterface
{
    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     *
     * @return object
     *
     * @throws \Psr\Container\ContainerExceptionInterface
     * @throws \Psr\Container\NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $pipeline = new MotoMiddleware($container->get('gath.selected_motorcycle'));

        $pipeline->pipe($container->get('gath.motorcycle_slug'));
        $pipeline->pipe($container->get('gath.select_motorcycle_handler'));

        return $pipeline;
    }
}