<?php
namespace Ep\Gath\Plugin;

/**
 * Class Brands
 *
 * @package Ep\Gath\Plugin
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/woocommerce
 */
class Brands extends AbstractGathPlugin
{
    protected $brandsById = [];

    public function __invoke(): void
    {
        add_filter('get_terms', [$this, 'get_terms'], 10, 3);
    }

    public function get_terms($terms, $taxonomy, $query_vars): array
    {
        if ($taxonomy === 'product_brand' || (count($taxonomy) === 1 && in_array('product_brand', $taxonomy)) && isset($query_vars['category'])) {
            $genericArticleIds = get_term_meta($query_vars['category'], 'genericArticleIds', true);

            if (!$genericArticleIds) {
                $data = $this->gath->getBrandsByCategory($query_vars['category']);

                foreach ($data['Results'] as $brand) {
                    $this->brandsById[$brand['id']] = $brand;
                    $terms[] = new \WP_Term((object) [
                        'term_id' => $brand['id'],
                        'name' => $brand['name'],
                        'image' => rtrim($this->gath->getImageBaseUri(), '/') . '/images/' . ltrim($brand['image'], '/'),
                    ]);
                }
            }
        }

        return $terms;
    }
}